#include <sqlextract/command.h>
#include <sqlextract/util.h>
#include <sqlextract/format.h>
#include <stdlib.h>

struct command_t {
	int (*execute)(void *, void *, struct output_formatter_t *formatter);
	void (*destroy)(void *);
	void *storage;
};

struct command_t *command_create(int (*execute)(void *, void *, struct output_formatter_t *formatter),
		void (*destroy)(void *), void *storage) {
	struct command_t *cmd = lf_malloc(sizeof(struct command_t));
	cmd->execute = execute;
	cmd->destroy = destroy;
	cmd->storage = storage;
	return cmd;

}

void command_destroy(struct command_t *cmd) {
	if (cmd == NULL)
		return;
	(*cmd->destroy)(cmd->storage);
	free(cmd);
}

int command_execute(struct command_t *cmd, void *arg,
		struct output_formatter_t *formatter) {
	return (*cmd->execute)(cmd->storage, arg, formatter);
}
